/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: CheckInputDlg.cpp
**
** DESCRIPTION: This program implements the methods of CheckInputDlg class
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/

// CheckInputDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RealTracker.h"
#include "CheckInputDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCheckInputDlg dialog


CCheckInputDlg::CCheckInputDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCheckInputDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCheckInputDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CCheckInputDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCheckInputDlg)
	DDX_Control(pDX, IDC_PROGRESS_WAITTIME, m_ctrlWaitTime);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCheckInputDlg, CDialog)
	//{{AFX_MSG_MAP(CCheckInputDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCheckInputDlg message handlers

BOOL CCheckInputDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    GetDlgItem(IDOK)->SetFocus();

    m_nTimeTick = 0;
    m_nTotalTick = 10;
    m_ctrlWaitTime.SetPos(0);
    m_nTimer = SetTimer(0x1011, 1000, 0);
	
	return TRUE;  // return TRUE unless you set the focus to a control
}

void CCheckInputDlg::OnTimer(UINT nIDEvent) 
{
    if (nIDEvent != m_nTimer)
    {
	    CDialog::OnTimer(nIDEvent);
        return;
    }

    m_nTimeTick ++;
    m_ctrlWaitTime.SetPos(m_nTimeTick * 100 / m_nTotalTick);
    if (m_nTimeTick == m_nTotalTick)
    {
        KillTimer(m_nTimer);
        OnCancel();
    }

	// Eat spurious WM_TIMER messages
	MSG msg;
	while(::PeekMessage(&msg, m_hWnd, WM_TIMER, WM_TIMER, PM_REMOVE));
}
