/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: CMediaLog.h
**
** DESCRIPTION: This class contains the information for each clip played
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/



// MediaLog.h: interface for the CMediaLog class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MEDIALOG_H__1A0D1C24_F061_42A3_B017_6B4294165E4F__INCLUDED_)
#define AFX_MEDIALOG_H__1A0D1C24_F061_42A3_B017_6B4294165E4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VQTest.h"
#include "MediaStatistics.h"

class CVQTest;
class CMediaStatistics;

class CMediaLog
{
private:
    CVQTest *m_VQTest;
    CString m_MediaFileName;
    CString m_LogFileName;
    CMediaStatistics *m_AudioStats;
    CMediaStatistics *m_VideoStats;
    char *m_ServerInfo;
    char *m_VideoCodecName;

public:
    int m_NumSec;
    int *m_NumPerSec;
    int m_curPointer;
    double *m_FrameIntervalBuf;

public:
	CMediaLog();
	CMediaLog(CVQTest *pVQTest);
	virtual ~CMediaLog();

    CVQTest *GetVQTest();
    CString GetMediaFileName();
    CString GetLogFileName();
    CMediaStatistics *GetAudioStats();
    CMediaStatistics *GetVideoStats();
    char *GetServerInfo();
    char *GetVideoCodecName();

    void SetVQTest(CVQTest *pVQTest);
    void SetMediaFileName(CString MediaFileName);
    void SetLogFileName(CString LogFileName);
    void SetAudioStats(CMediaStatistics *pAudioStats);
    void SetVideoStats(CMediaStatistics *pVideoStats);

    void InitAudioStats(int maxDataNum);
    void InitVideoStats(int maxDataNum);
    void AddAudioStatsData(VQData *pData);
    void AddVideoStatsData(VQData *pData);
    void AddAudioJitterData(VQJitter *pJitter);
    void AddVideoJitterData(VQJitter *pJitter);

    void AddInterval(int n, double *intervals);
};

#endif // !defined(AFX_MEDIALOG_H__1A0D1C24_F061_42A3_B017_6B4294165E4F__INCLUDED_)
