/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: CMediaStatistics.h
**
** DESCRIPTION: This class defies the linkedlists that store the statistics for 
**              each clip played.
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/



// MediaStatistics.h: interface for the CMediaStatistics class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MEDIASTATISTICS_H__24769592_FBEE_4D57_9106_FD909442D3C1__INCLUDED_)
#define AFX_MEDIASTATISTICS_H__24769592_FBEE_4D57_9106_FD909442D3C1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VQData.h"

class CMediaStatistics : public CObject
{
private:
    int m_VQDataNum;
    int m_maxVQDataNum;
    VQDataLink *m_VQDataHead;
    VQDataLink *m_VQDataTail;

    int m_VQJitterNum;
    int m_maxVQJitterNum;
    VQJitterLink *m_VQJitterHead;
    VQJitterLink *m_VQJitterTail;

public:
	CMediaStatistics();
	CMediaStatistics(int maxDataNum);
	virtual ~CMediaStatistics();

    int GetVQDataNum();
    VQData *GetVQDataFirst(VQDataLink *&pVQDataLink);
    VQData *GetVQDataNext(VQDataLink *&pVQDataLink);

    int GetVQJitterNum();
    VQJitter *GetVQJitterFirst(VQJitterLink *&pVQJitterLink);
    VQJitter *GetVQJitterNext(VQJitterLink *&pVQJitterLink);

    void Init(int maxVQDataNum);
    void AddVQData(VQData *pVQData);
    void AddVQJitter(VQJitter *pVQJitter);
};

#endif // !defined(AFX_MEDIASTATISTICS_H__24769592_FBEE_4D57_9106_FD909442D3C1__INCLUDED_)
