/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: Preference.h
**
** DESCRIPTION: This files contains two strutures:
**              Preference, which contains the user and system information, and
**              AdvancedPreference, which contains the FTP and email server information
**              specified by distributors         
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


// Preference.h
//
//////////////////////////////////////////////////////////////////////

#if !defined(_PREFERENCE_H_)
#define _PREFERENCE_H_

#define OSTYPE_WINDOWS9598      0
#define OSTYPE_WINDOWSNT35      1
#define OSTYPE_WINDOWSNT4       2
#define OSTYPE_WINDOWS2000      3
#define OSTYPE_OTHER            4

#define NETCONFIG_144K          0
#define NETCONFIG_192K          1
#define NETCONFIG_288K          2
#define NETCONFIG_336K          3
#define NETCONFIG_56K           4
#define NETCONFIG_ISDN          5
#define NETCONFIG_DSLCABLE      6
#define NETCONFIG_LAN           7

#define PLAYTIME_ONE            0
#define PLAYTIME_TWO            1
#define PLAYTIME_THREE          2
#define PLAYTIME_WHOLE          3

#define CHECKQUALITY_NEVER      0
#define CHECKQUALITY_ALWAYS     1
#define CHECKQUALITY_BYCHOICE   2

struct Preference
{
    BOOL IsFirstRun;
    CString UserName;
    CString EmailAddr;
    CString Country;
    CString State;
    CString CPUType;
    int MEMCap;
    int OSType;
    int UserCpu;
    int NetConfig;
    int PlayTime;
    int CheckQuality;
    CString LogFile;
};


struct AdvancedPreference
{
    BOOL bUseMail1;
    CString SMTPServer1;
    CString UserName1;
    CString UserAddr1;

    BOOL bUseMail2;
    CString SMTPServer2;
    CString UserName2;
    CString UserAddr2;

    BOOL bUseFtp1;
    CString ftpServer1;
    CString ftpUser1;
    CString ftpPasswd1;
    CString ftpDir1;

    BOOL bUseFtp2;
    CString ftpServer2;
    CString ftpUser2;
    CString ftpPasswd2;
    CString ftpDir2;

    AdvancedPreference()
    {
        bUseMail1 = FALSE;
        SMTPServer1 = "";
        UserName1 = "";
        UserAddr1 = "";

        bUseMail2 = FALSE;
        SMTPServer2 = "";
        UserName2 = "";
        UserAddr2 = "";

        bUseFtp1 = FALSE;
        ftpServer1 = "";
        ftpUser1 = "";
        ftpPasswd1 = "";
        ftpDir1 = "";

        bUseFtp2 = FALSE;;
        ftpServer2 = "";
        ftpUser2 = "";
        ftpPasswd2 = "";
        ftpDir2 = "";
    }
};

#endif // !defined(_PREFERENCE_H_)
