/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: RealTracker.h
**
** DESCRIPTION: This class defines the RealTracker main program
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


// RealTracker.h : main header file for the REALTRACKER application
//

#if !defined(AFX_REALTRACKER_H__8DEEA9B4_3CCF_4F8F_8224_21B926A9CE24__INCLUDED_)
#define AFX_REALTRACKER_H__8DEEA9B4_3CCF_4F8F_8224_21B926A9CE24__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

#include "RealTrackerDoc.h"
#include "Preference.h"

/////////////////////////////////////////////////////////////////////////////
// CRealTrackerApp:
// See RealTracker.cpp for the implementation of this class
//

class CRealTrackerApp : public CWinApp
{
public:
	CRealTrackerApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRealTrackerApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CRealTrackerApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
    BOOL IsFirstRun();
    void GetUserOption(Preference &option);
    void WriteUserOption(const Preference &option);

    BYTE ByteMap(BYTE data);
    void EncodeWrite(FILE *fp, CString str);
    BOOL DecodeRead(FILE *fp, CString &str);
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_REALTRACKER_H__8DEEA9B4_3CCF_4F8F_8224_21B926A9CE24__INCLUDED_)
