/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: RealTrackerDoc.cpp
**
** DESCRIPTION: This program implements the methods of CRealTrackerDoc class
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang       March-2001
**
/**************************************************************************/


// RealTrackerDoc.cpp : implementation of the CRealTrackerDoc class
//

#include "stdafx.h"
#include "RealTracker.h"

#include "RealTrackerDoc.h"
#include "ResultDeliveryDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRealTrackerDoc

IMPLEMENT_DYNCREATE(CRealTrackerDoc, CDocument)

BEGIN_MESSAGE_MAP(CRealTrackerDoc, CDocument)
	//{{AFX_MSG_MAP(CRealTrackerDoc)
	ON_COMMAND(ID_FILE_MAKECONFIG, OnFileMakeconfig)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRealTrackerDoc construction/destruction

CRealTrackerDoc::CRealTrackerDoc()
{
	// TODO: add one-time construction code here

}

CRealTrackerDoc::~CRealTrackerDoc()
{
}

BOOL CRealTrackerDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CRealTrackerDoc serialization

void CRealTrackerDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRealTrackerDoc diagnostics

#ifdef _DEBUG
void CRealTrackerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CRealTrackerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


int CRealTrackerDoc::GetProgListNum()
{
    return m_ProgDspt.GetSize();
}

CString CRealTrackerDoc::GetProgDspt(int index)
{
    return m_ProgDspt[index];
}

CString CRealTrackerDoc::GetProgList(int index)
{
    return m_ProgList[index];
}

/////////////////////////////////////////////////////////////////////////////
// CRealTrackerDoc commands

BOOL CRealTrackerDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
    if (!CDocument::OnOpenDocument(lpszPathName))
        return FALSE;

    FILE *fp = fopen(lpszPathName, "r");
    if (fp == NULL)
    {
        CString msg;
        msg.Format("Can't open file %s", lpszPathName);
        AfxGetMainWnd()->MessageBox(msg, "Error");
        return FALSE;
    }

    m_ProgDspt.RemoveAll();
    m_ProgList.RemoveAll();

    char buffer[4096];
    while (! feof(fp) )
    {
        if (fgets(buffer, 4096, fp) == NULL)
            break;
        buffer[strlen(buffer)-1] = 0;
        m_ProgDspt.Add(buffer);
        fgets(buffer, 4096, fp);
        buffer[strlen(buffer)-1] = 0;
        m_ProgList.Add(buffer);
    }

    UpdateAllViews(NULL);

    return TRUE;
}

/* file format

[AutoMail]
AutoMail=on
SMTP_Server=smtp.server.com
Receiver_Name=John Smith
Receiver_EMmail=user@server.com
[AutoMail]
AutoMail=off
SMTP_Server=
Receiver_Name=
Receiver_EMmail=
[AutoFTP]
AutoFTP=off
FTP_Server=
User=
Passwd=
Dir=
[AutoFTP]
AutoFTP=on
FTP_Server=ftp.server.com
User=user
Passwd=passwd
Dir=realdata

*/

void CRealTrackerDoc::OnFileMakeconfig() 
{
    CResultDeliveryDlg dlg;
    if (dlg.DoModal() != IDOK)
        return;

    CString filename = "RT.cfg";
    FILE *fp = fopen(filename, "wb");
    if (fp == NULL)
    {
        CString msg;
        msg.Format("Can't open file %s to write", filename);
        AfxGetMainWnd()->MessageBox(msg, "Error");
        return;
    }

    if (dlg.m_bMailAddr1)
        WriteAutoMail(fp, TRUE, dlg.m_SMTPServer1, dlg.m_MailName1, dlg.m_MailAddr1);
    else
        WriteAutoMail(fp, FALSE, "", "", "");

    if (dlg.m_bMailAddr2)
        WriteAutoMail(fp, TRUE, dlg.m_SMTPServer2, dlg.m_MailName2, dlg.m_MailAddr2);
    else
        WriteAutoMail(fp, FALSE, "", "", "");

    if (dlg.m_bUseFtp1)
        WriteAutoFTP(fp, TRUE, dlg.m_FTPServer1, dlg.m_FTPUser1, dlg.m_FTPPasswd1, dlg.m_FTPDir1);
    else
        WriteAutoFTP(fp, FALSE, "", "", "", "");

    if (dlg.m_bUseFtp2)
        WriteAutoFTP(fp, TRUE, dlg.m_FTPServer2, dlg.m_FTPUser2, dlg.m_FTPPasswd2, dlg.m_FTPDir2);
    else
        WriteAutoFTP(fp, FALSE, "", "", "", "");

    fclose(fp);
}

void CRealTrackerDoc::WriteAutoMail(FILE *fp, BOOL bAutoMail, CString server, CString name, CString email)
{
    CString str;

    CRealTrackerApp *pApp = (CRealTrackerApp*) AfxGetApp();

    str = "[AutoMail]";
    pApp->EncodeWrite(fp, str);

    str.Format("AutoMail=%s", bAutoMail ? "on" : "off");
    pApp->EncodeWrite(fp, str);

    str.Format("SMTP_Server=%s", server);
    pApp->EncodeWrite(fp, str);

    str.Format("Receiver_Name=%s", name);
    pApp->EncodeWrite(fp, str);

    str.Format("Receiver_EMmail=%s", email);
    pApp->EncodeWrite(fp, str);
}

void CRealTrackerDoc::WriteAutoFTP(FILE *fp, BOOL bAutoFTP, CString server, CString user, CString passwd, CString dir)
{
    CString str;

    CRealTrackerApp *pApp = (CRealTrackerApp*) AfxGetApp();

    str = "[AutoFTP]";
    pApp->EncodeWrite(fp, str);

    str.Format("AutoFTP=%s", bAutoFTP ? "on" : "off");
    pApp->EncodeWrite(fp, str);

    str.Format("FTP_Server=%s", server);
    pApp->EncodeWrite(fp, str);

    str.Format("User=%s", user);
    pApp->EncodeWrite(fp, str);

    str.Format("Passwd=%s", passwd);
    pApp->EncodeWrite(fp, str);

    str.Format("Dir=%s", dir);
    pApp->EncodeWrite(fp, str);
}

BOOL CRealTrackerDoc::ReadAutoConfig(AdvancedPreference &AdvPref)
{
    CString filename = "RT.cfg";
    FILE *fp = fopen(filename, "rb");
    if (fp == NULL)
    {
        CString msg;
        msg.Format("Can't open configure file %s to read", filename);
        AfxGetMainWnd()->MessageBox(msg, "Error");
        return FALSE;
    }

    if (! ReadAutoMail(fp, AdvPref.bUseMail1, AdvPref.SMTPServer1, AdvPref.UserName1, AdvPref.UserAddr1) ||
        ! ReadAutoMail(fp, AdvPref.bUseMail2, AdvPref.SMTPServer2, AdvPref.UserName2, AdvPref.UserAddr2) ||
        ! ReadAutoFTP(fp, AdvPref.bUseFtp1, AdvPref.ftpServer1, AdvPref.ftpUser1, AdvPref.ftpPasswd1, AdvPref.ftpDir1) ||
        ! ReadAutoFTP(fp, AdvPref.bUseFtp2, AdvPref.ftpServer2, AdvPref.ftpUser2, AdvPref.ftpPasswd2, AdvPref.ftpDir2))
    {
        CString msg;
        msg.Format("Configure file %s format error", filename);
        AfxGetMainWnd()->MessageBox(msg, "Error");
        fclose(fp);
        return FALSE;
    }

    fclose(fp);

    return TRUE;
}

BOOL CRealTrackerDoc::ReadAutoMail(FILE *fp, BOOL &bAutoMail, CString &server, CString &name, CString &email)
{
    CString str;

    CRealTrackerApp *pApp = (CRealTrackerApp*) AfxGetApp();

    if (! pApp->DecodeRead(fp, str))
        return FALSE;
    if (strcmp((LPCSTR)str, "[AutoMail]") != 0)
        return FALSE;

    if (! pApp->DecodeRead(fp, str))
        return FALSE;
    if (strcmp((LPCSTR)str, "AutoMail=on") == 0)
        bAutoMail = TRUE;
    else if (strcmp((LPCSTR)str, "AutoMail=off") == 0)
        bAutoMail = FALSE;
    else
        return FALSE;

    if (! pApp->DecodeRead(fp, str))
        return FALSE;
    if (strncmp((LPCSTR)str, "SMTP_Server=", 12) != 0)
        return FALSE;
    server = str.Mid(12);

    if (! pApp->DecodeRead(fp, str))
        return FALSE;
    if (strncmp((LPCSTR)str, "Receiver_Name=", 14) != 0)
        return FALSE;
    name = str.Mid(14);

    if (! pApp->DecodeRead(fp, str))
        return FALSE;
    if (strncmp((LPCSTR)str, "Receiver_EMmail=", 16) != 0)
        return FALSE;
    email = str.Mid(16);

    return TRUE;
}

BOOL CRealTrackerDoc::ReadAutoFTP(FILE *fp, BOOL &bAutoFTP, CString &server, CString &user, CString &passwd, CString &dir)
{
    CString str;

    CRealTrackerApp *pApp = (CRealTrackerApp*) AfxGetApp();

    if (! pApp->DecodeRead(fp, str))
        return FALSE;
    if (strcmp((LPCSTR)str, "[AutoFTP]") != 0)
        return FALSE;

    if (! pApp->DecodeRead(fp, str))
        return FALSE;
    if (strcmp((LPCSTR)str, "AutoFTP=on") == 0)
        bAutoFTP = TRUE;
    else if (strcmp((LPCSTR)str, "AutoFTP=off") == 0)
        bAutoFTP = FALSE;
    else
        return FALSE;

    if (! pApp->DecodeRead(fp, str))
        return FALSE;
    if (strncmp((LPCSTR)str, "FTP_Server=", 11) != 0)
        return FALSE;
    server = str.Mid(11);

    if (! pApp->DecodeRead(fp, str))
        return FALSE;
    if (strncmp((LPCSTR)str, "User=", 5) != 0)
        return FALSE;
    user = str.Mid(5);

    if (! pApp->DecodeRead(fp, str))
        return FALSE;
    if (strncmp((LPCSTR)str, "Passwd=", 7) != 0)
        return FALSE;
    passwd = str.Mid(7);

    if (! pApp->DecodeRead(fp, str))
        return FALSE;
    if (strncmp((LPCSTR)str, "Dir=", 4) != 0)
        return FALSE;
    dir = str.Mid(4);

    return TRUE;
}
