/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: SocketX.h
**
** DESCRIPTION: This class is an extension of the CSocket class.
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


// SOCKETX.H -- Extension of the CSocket class
//

#ifndef __SOCKETX_H__
#define __SOCKETX_H__

#include <afxsock.h>		// MFC socket extensions

class CSocketX : public CSocket
{
	DECLARE_DYNAMIC(CSocketX);

// Implementation
public:
	int Send(LPCTSTR lpszStr, UINT uTimeOut = 0, int nFlags = 0);
	int Receive(CString& str, UINT uTimeOut = 0, int nFlags = 0);
	BOOL SetTimeOut(UINT uTimeOut);
	BOOL KillTimeOut();

    BOOL ConnectToServer(CString serverName);
    BOOL SendAndResponse(CString strCommand, UINT uTimeOut, CString chkWord);

protected: 
	virtual BOOL OnMessagePending();

private: 
	int m_nTimerID;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // __SOCKETX_H__
