/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: SysStatus.h
**
** DESCRIPTION: This class records the system information
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


// SysStatus.h: interface for the CSysStatus class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SYSSTATUS_H__C1B56BA6_9342_480F_BA59_F1278707E0FA__INCLUDED_)
#define AFX_SYSSTATUS_H__C1B56BA6_9342_480F_BA59_F1278707E0FA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <pdh.h>

#ifdef UNICODE
typedef PDH_STATUS (__stdcall *FPDHOPENQUERY)(IN LPCWSTR szDataSource, IN DWORD dwUserData, IN HQUERY *phQuery);
typedef PDH_STATUS (__stdcall *FPDHADDCOUNTER)(IN HQUERY hQuery, IN LPCWSTR szFullCounterPath, IN DWORD dwUserData, IN HCOUNTER *phCounter);
#define PDHOPENQUERY_NAME                   "PdhOpenQueryW"
#define PDHADDCOUNTER_NAME                  "PdhAddCounterW"
#else
typedef PDH_STATUS (__stdcall *FPDHOPENQUERY)(IN LPCSTR szDataSource, IN DWORD dwUserData, IN HQUERY *phQuery);
typedef PDH_STATUS (__stdcall *FPDHADDCOUNTER)(IN HQUERY hQuery, IN LPCSTR szFullCounterPath, IN DWORD dwUserData, IN HCOUNTER *phCounter);
#define PDHOPENQUERY_NAME                   "PdhOpenQueryA"
#define PDHADDCOUNTER_NAME                  "PdhAddCounterA"
#endif

typedef PDH_STATUS (__stdcall *FPDHCLOSEQUERY)(IN HQUERY hQuery);
typedef PDH_STATUS (__stdcall *FPDHCOLLECTQUERYDATA)(IN HQUERY hQuery);
typedef PDH_STATUS (__stdcall *FPDHGETFORMATTEDCOUNTERVALUE)(IN HCOUNTER hCounter, IN DWORD dwFormat, IN LPDWORD lpdwType, IN PPDH_FMT_COUNTERVALUE pValue);
#define PDHCLOSEQUERY_NAME                  "PdhCloseQuery"
#define PDHCOLLECTQUERYDATA_NAME            "PdhCollectQueryData"
#define PDHGETFORMATTEDCOUNTERVALUE_NAME    "PdhGetFormattedCounterValue"

typedef long (__stdcall *FPGETCPULOAD98)(long *);
#define GETCPULOAD98_NAME                   "GetCpuLoad"

class CString;

class CSysStatus  
{
private:
    char m_strMachineName[MAX_COMPUTERNAME_LENGTH + 1];
    char m_strIPAddr[256];

    int m_bPdhSupport;        // 0: don't support, 1: support 95/98, 2: support nt/2000
    HMODULE m_hDll;
    FPGETCPULOAD98 m_fpGetCpuLoad98;
    FPDHOPENQUERY m_fpPdhOpenQuery;
    FPDHCLOSEQUERY m_fpPdhCloseQuery;
    FPDHADDCOUNTER m_fpPdhAddCounter;
    FPDHCOLLECTQUERYDATA m_fpPdhCollectQueryData;
    FPDHGETFORMATTEDCOUNTERVALUE m_fpPdhGetFormattedCounterValue;

    HQUERY m_hQuery_cpu;
    HCOUNTER m_CounterHandle;

public:
	CSysStatus();
	virtual ~CSysStatus();

    static CString GetCpuType();
    static int GetMemory();
    static int GetOSType();
    CString GetMachineName();
    CString GetIPAddr();
    double GetCpuUsage();
};

extern CSysStatus theSysStatus;

#endif // !defined(AFX_SYSSTATUS_H__C1B56BA6_9342_480F_BA59_F1278707E0FA__INCLUDED_)
