/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: TimeStatusBar.cpp
**
** DESCRIPTION: This program implements the methods of CTimeStatusBar class
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang       March-2001
**
/**************************************************************************/


// TimeStatusBar.cpp: implementation of the CTimeStatusBar class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RealTracker.h"
#include "TimeStatusBar.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CTimeStatusBar

IMPLEMENT_DYNCREATE(CTimeStatusBar, CStatusBar)

BEGIN_MESSAGE_MAP(CTimeStatusBar, CStatusBar)
	//{{AFX_MSG_MAP(CTimeStatusBar)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTimeStatusBar::CTimeStatusBar()
{
}

CTimeStatusBar::~CTimeStatusBar()
{
    if (m_ProgressCtrl.m_hWnd != NULL)
        m_ProgressCtrl.DestroyWindow();
}

void CTimeStatusBar::OnSize(UINT nType, int cx, int cy)
{
    CStatusBar::OnSize(nType, cx, cy);
    PositionControls();
}

BOOL CTimeStatusBar::AddProgressControl()
{
    // position and size will be adjusted
    RECT rect;
    rect.left = 100;
    rect.right = 105;
    rect.top = 100;
    rect.bottom = 105;
    if (! m_ProgressCtrl.Create(WS_CHILD|WS_BORDER, rect, this, 1))
    {
        TRACE0("Failed to create ProgressControl\n");
        return FALSE;
    }
    m_ProgressCtrl.ShowWindow(SW_SHOW);

    return TRUE;
}

void CTimeStatusBar::SetProgressPos(int pos)
{
    m_ProgressCtrl.SetPos(pos);
}

void CTimeStatusBar::PositionControls()
{
    int ProgressPane = CommandToIndex(ID_INDICATOR_PROGRESS);
    if (m_ProgressCtrl.m_hWnd == NULL || ProgressPane == -1)
        return;

    CRect rect;
    GetItemRect(ProgressPane, &rect);
    rect.top += 3;
    rect.bottom -= 3;
    m_ProgressCtrl.MoveWindow(rect);
}
