/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: VQTest.h
**
** DESCRIPTION: This class is intermediate class that connects CRealTrackerView 
                and CMediaLog/CRMAContext
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


// VQTest.h: interface for the CVQTest class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VQTEST_H__09564CC1_93E9_4909_8A00_8DAF2C054A72__INCLUDED_)
#define AFX_VQTEST_H__09564CC1_93E9_4909_8A00_8DAF2C054A72__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RealTrackerView.h"
//#include "Option.h"
#include "MediaLog.h"
#include "RMAContext.h"

class CRealTrackerView;
class CMediaLog;
class CRMAContext;

class CVQTest : public CObject
{
private:
    CRealTrackerView *m_pView;
    CMediaLog *m_MediaLog;
    CRMAContext *m_RMAContext;

public:
	CVQTest(CRealTrackerView *pView);
	virtual ~CVQTest();

    CRealTrackerView *GetRealTrackerView();
    CMediaLog *GetMediaLog();
    CRMAContext *GetRMAContext();

    void ShowTimeLine(long CurTime, long TotalTime);
    void InitAudioStats(int maxDataNum);
    void InitVideoStats(int maxDataNum);
    void AddAudioStats(VQData *pData);
    void AddVideoStats(VQData *pData);
    void AddVideoJitter(VQJitter *pData);
};

#endif // !defined(AFX_VQTEST_H__09564CC1_93E9_4909_8A00_8DAF2C054A72__INCLUDED_)
