/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: RealDataView.h
**
** DESCRIPTION: This class defines the view structure for RealData program
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


// RealDataView.h : interface of the CRealDataView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_REALDATAVIEW_H__2BA1FDEC_6B17_4A6D_BF9B_CF7DACB0754A__INCLUDED_)
#define AFX_REALDATAVIEW_H__2BA1FDEC_6B17_4A6D_BF9B_CF7DACB0754A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CRealDataDoc;
class CRealTreeView;
class CRealListView;

class CRealDataView : public CView
{
protected: // create from serialization only
	CRealDataView();
	DECLARE_DYNCREATE(CRealDataView)

// Attributes
protected:
    CSplitterWnd m_wndSplitter;

// Attributes
public:
	CRealDataDoc* GetDocument();

    CRealTreeView *GetTreeView();
    CRealListView *GetListView();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRealDataView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CRealDataView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CRealDataView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in RealDataView.cpp
inline CRealDataDoc* CRealDataView::GetDocument()
   { return (CRealDataDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_REALDATAVIEW_H__2BA1FDEC_6B17_4A6D_BF9B_CF7DACB0754A__INCLUDED_)
