/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: RealListView.h
**
** DESCRIPTION: This class defines the view for right window of RealData Program
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


#if !defined(AFX_REALLISTVIEW_H__38D94833_E26F_4D15_BD74_335967D8C093__INCLUDED_)
#define AFX_REALLISTVIEW_H__38D94833_E26F_4D15_BD74_335967D8C093__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RealListView.h : header file
//

#include "RealDataDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CRealListView view

class CRealListView : public CListView
{
private:
    BOOL m_bInitialized;
    int m_numberOfListViewColumns;

public:
    int m_nCurItemIndex;
    int m_nSortedColumn;
    int m_nSortDirect;     // 0:none  1:Ascending  2:Descending

protected:
	CRealListView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CRealListView)

// Attributes
public:
    CRealDataDoc* GetDocument();
    void OnCdfFrAll();
    void OnCdfFrSelected();
	void OnCdfBwAll();
	void OnCdfBwSelected();
	void OnCdfJitterAll();
	void OnCdfJitterSelected();
    void OnCount();
    void OnEditDelete();

// Operations
public:
	void InitializeListView();
	void OnExport();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRealListView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CRealListView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CRealListView)
	afx_msg void OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclk(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

    void CdfBwAllAndSelected(int bSelected);
    void CdfJitterAllAndSelected(int bSelected);

public:
    void ChangeListView(int newItemIndex);
    void AddToListView(CRealData *pDataItem);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_REALLISTVIEW_H__38D94833_E26F_4D15_BD74_335967D8C093__INCLUDED_)
