/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: ShowLogHeadView.cpp
**
** DESCRIPTION: This program implements the methods of CShowLogHeadView class
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


// ShowLogHeadView.cpp : implementation file
//

#include "stdafx.h"
#include "RealData.h"
#include "ShowLogHeadView.h"
#include "ShowLogDoc.h"
#include "ShowLogView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShowLogHeadView

IMPLEMENT_DYNCREATE(CShowLogHeadView, CEditView)

CShowLogHeadView::CShowLogHeadView()
{
    m_bInitialized = FALSE;
}

CShowLogHeadView::~CShowLogHeadView()
{
}

CShowLogDoc *CShowLogHeadView::GetDocument()
{
    return ((CShowLogView *) GetParent()->GetParent())->GetDocument();
}


BEGIN_MESSAGE_MAP(CShowLogHeadView, CEditView)
	//{{AFX_MSG_MAP(CShowLogHeadView)
	ON_WM_CTLCOLOR_REFLECT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShowLogHeadView drawing

void CShowLogHeadView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CShowLogHeadView diagnostics

#ifdef _DEBUG
void CShowLogHeadView::AssertValid() const
{
	CEditView::AssertValid();
}

void CShowLogHeadView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CShowLogHeadView message handlers

BOOL CShowLogHeadView::PreCreateWindow(CREATESTRUCT& cs) 
{
    // TODO: Add your specialized code here and/or call the base class

    return CEditView::PreCreateWindow(cs);
}

void CShowLogHeadView::OnInitialUpdate() 
{
    CEditView::OnInitialUpdate();

    CEdit& theEditCtrl = GetEditCtrl();
    theEditCtrl.SetReadOnly();

    theEditCtrl.SetRedraw(FALSE); 
	COLORREF crYellow = RGB(240, 240, 200); //light yellow
//heEditCtrl.SetBkColor(crYellow);
//heListCtrl.SetTextBkColor(crYellow);

    CString filename = GetDocument()->GetFileName();
    FILE *fp = fopen(filename, "r");
    if (fp == NULL)
        return;

    char buf[400];
    CString szMessage;

    while (fgets(buf, 400, fp))
    {
        if (strncmp(buf, "CodedBw AvgBw TotalBw", 20) == 0)
        {
            while ( fgets(buf, 400, fp) )
            {
                if (strncmp(buf, "CodedBw AvgBw TotalBw", 20) == 0)
                    break;
            }
            continue;
        }
        if (strlen(buf) > 0 && buf[strlen(buf)-1] == 10)
            buf[strlen(buf)-1] = 0;
        szMessage += buf;
        szMessage += "\r\n";
    }
    fclose(fp);

    theEditCtrl.SetWindowText(szMessage);
    theEditCtrl.SetRedraw(TRUE);
	theEditCtrl.Invalidate(); 
}

HBRUSH CShowLogHeadView::CtlColor(CDC* pDC, UINT nCtlColor) 
{
/*    switch (nCtlColor)
    {
        case CTLCOLOR_EDIT:
        case CTLCOLOR_MSGBOX:
            // Set color to green on black and return the background brush.
            pDC->SetTextColor(RGB(0, 255, 0));
            pDC->SetBkColor(RGB(240, 240, 200));
            //return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
            //return CEditView::OnCtlColor(pDC, NULL, nCtlColor);
            break;

        default:
            //return CEditView::OnCtlColor(pDC, NULL, nCtlColor);
            break;
    }*/

	// TODO: Return a non-NULL brush if the parent's handler should not be called
	return NULL;
}
