/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: ShowLogListView.cpp
**
** DESCRIPTION: This program implements the methods of CShowLogListView class
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


// ShowLogListView.cpp : implementation file
//

#include "stdafx.h"
#include "RealData.h"
#include "ShowLogListView.h"
#include "ShowLogDoc.h"
#include "ShowLogView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShowLogListView

IMPLEMENT_DYNCREATE(CShowLogListView, CListView)

CShowLogListView::CShowLogListView()
{
    m_bInitialized = FALSE;
}

CShowLogListView::~CShowLogListView()
{
}

CShowLogDoc *CShowLogListView::GetDocument()
{
    return ((CShowLogView *) GetParent()->GetParent())->GetDocument();
}


BEGIN_MESSAGE_MAP(CShowLogListView, CListView)
	//{{AFX_MSG_MAP(CShowLogListView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShowLogListView drawing

void CShowLogListView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CShowLogListView diagnostics

#ifdef _DEBUG
void CShowLogListView::AssertValid() const
{
	CListView::AssertValid();
}

void CShowLogListView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CShowLogListView message handlers

BOOL CShowLogListView::PreCreateWindow(CREATESTRUCT& cs) 
{
    cs.style |= LVS_SHOWSELALWAYS | LVS_REPORT;
	
	return CListView::PreCreateWindow(cs);
}

void CShowLogListView::OnInitialUpdate() 
{
	CListView::OnInitialUpdate();
	
    if (m_bInitialized)
        return;
    m_bInitialized = TRUE;

    CListCtrl& theListCtrl = GetListCtrl();

    theListCtrl.SetRedraw(FALSE); 
	
	DWORD dwExStyle = LVS_EX_FULLROWSELECT;
	theListCtrl.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, (WPARAM)dwExStyle, (LPARAM)dwExStyle);
	COLORREF crYellow = RGB(240, 240, 200); //light yellow
	theListCtrl.SetBkColor(crYellow);
	theListCtrl.SetTextBkColor(crYellow);

    CString filename = GetDocument()->GetFileName();
    FILE *fp = fopen(filename, "r");
    if (fp == NULL)
        return;

    BOOL cont = TRUE;
    int i, j, num;
    char buf[400], *p1, *p2;
    while (cont)
    {
        if (! fgets(buf, 400, fp))
            cont = FALSE;
        else if (strncmp(buf, "CodedBw AvgBw TotalBw", 20) == 0)
            break;
    }

    if (! cont)
    {
        fclose(fp);
        return;
    }

    i = 0;
    p1 = p2 = buf;
    while (p2)
    {
        p2 = strchr(p1, ' ');
        if (p2 == NULL)
            p2 = strchr(p1, 0x0a);
        if (p2)
            *p2 = 0;
        if (*p1)
            theListCtrl.InsertColumn(i++, p1);
        if (p2)
            p1 = p2 + 1;
    }
    num = i;

    j = 0;
    while ( 1 )
    {
        if (! fgets(buf, 400, fp))
            break;
        else if (strncmp(buf, "CodedBw AvgBw TotalBw", 20) == 0)
            break;

        i = 0;
        p1 = p2 = buf;
        while (p2)
        {
            p2 = strchr(p1, ' ');
            if (p2 == NULL)
                p2 = strchr(p1, 0x0a);
            if (p2)
                *p2 = 0;
            if (*p1)
            {
                if (i == 0)
                    theListCtrl.InsertItem(j, p1);
                else
                    theListCtrl.SetItemText(j, i, p1);
            }
            i ++;
            if (p2)
                p1 = p2 + 1;
        }
        j ++;
    }
    fclose(fp);

    for (i=0; i<num; i++)
		theListCtrl.SetColumnWidth(i, LVSCW_AUTOSIZE_USEHEADER); 

    theListCtrl.SetRedraw(TRUE);
	theListCtrl.Invalidate(); 
}
