/**************************************************************************
**
** Copyright (C) Computer Science Department, Worcester Polytechnic Institute,
**                           All rights reserved.
**
** FILE NAME: ShowLogView.cpp
**
** DESCRIPTION: This program implements the methods of CShowLogView class
**              
**
** AUTHOR: Zheng Zuo/Yubing Wang        March-2001
**
/**************************************************************************/


// ShowLogView.cpp : implementation file
//

#include "stdafx.h"
#include "RealData.h"
#include "ShowLogDoc.h"
#include "ShowLogView.h"
#include "ShowLogHeadView.h"
#include "ShowLogListView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShowLogView

IMPLEMENT_DYNCREATE(CShowLogView, CView)

CShowLogView::CShowLogView()
{
}

CShowLogView::~CShowLogView()
{
}


BEGIN_MESSAGE_MAP(CShowLogView, CView)
	//{{AFX_MSG_MAP(CShowLogView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShowLogView drawing

void CShowLogView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CShowLogView diagnostics

#ifdef _DEBUG
void CShowLogView::AssertValid() const
{
	CView::AssertValid();
}

void CShowLogView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CShowLogDoc* CShowLogView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CShowLogDoc)));
	return (CShowLogDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CShowLogView message handlers

int CShowLogView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	CCreateContext *pContext = (CCreateContext*)lpCreateStruct->lpCreateParams;
	lpCreateStruct->style |= WS_OVERLAPPED;
    m_wndSplitter.CreateStatic(this, 2, 1);
    m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS(CShowLogHeadView), CSize(0, 0), pContext);
    m_wndSplitter.CreateView(1, 0, RUNTIME_CLASS(CShowLogListView), CSize(0, 0), pContext);

	return 0;
}

void CShowLogView::OnSize(UINT nType, int cx, int cy) 
{
    CView::OnSize(nType, cx, cy);

    m_wndSplitter.MoveWindow(0, 0, cx, cy);
    m_wndSplitter.SetRowInfo(0, cy/3, 0);
    m_wndSplitter.RecalcLayout();  
}

void CShowLogView::OnInitialUpdate() 
{
    CView::OnInitialUpdate();

//    ((CView*)m_wndSplitter.GetPane(0, 0))->OnInitialUpdate();
//    ((CView*)m_wndSplitter.GetPane(1, 0))->OnInitialUpdate();
}
